/*
 * (c) 2011 lasconic <lasconic@gmail.com>
 * (c) 2011 leo franchi <lfranchi@kde.org>
 */
var DilandauResolver = OFusion.extend(OFusionResolver, {
    settings: {
        name: 'Dilandau',
        weight: 40,
        timeout: 10,
     	version: 1,
     	type: 'music'
        //strictMatch: true
    },
    parseISODuration: function (duration) {
        var splitDurationRegex_ = new RegExp('^(-)?P(?:(\\d+)Y)?(?:(\\d+)M)?(?:(\\d+)D)?' + '(T(?:(\\d+)H)?(?:(\\d+)M)?(?:(\\d+(?:\\.\\d+)?)S)?)?$');

        OFusion.log(typeof (duration));
        var parts = duration.match(splitDurationRegex_);
        if (!parts) {
            return null;
        }

        var timeEmpty = !(parts[6] || parts[7] || parts[8]);
        var dateTimeEmpty = timeEmpty && !(parts[2] || parts[3] || parts[4]);
        if (dateTimeEmpty || timeEmpty && parts[5]) {
            return 0;
        }

        var negative = parts[1];
        var years = parseInt(parts[2], 10) || 0;
        var months = parseInt(parts[3], 10) || 0;
        var days = parseInt(parts[4], 10) || 0;
        var hours = parseInt(parts[6], 10) || 0;
        var minutes = parseInt(parts[7], 10) || 0;
        var seconds = parseFloat(parts[8]) || 0;
        return negative ? (-days * 24 * 3600 - hours * 3600 - minutes * 60 - seconds) : (days * 24 * 3600 + hours * 3600 + minutes * 60 + seconds);

    },
    handleResponse: function (qid, artist, album, title, strictMatch) {
        var that = this;
        return function (xhr) {

			if(!(xhr.responseText))
			{
				var results = new Array();
            			var return1 = {
					qid: qid,
					results: results
				};
				OFusion.addTrackResults(return1);
				return;
			}

            var matches = [];
            var xmlString = xhr.responseText;
	    OFusion.log("dilandau : strictMatch = " + strictMatch);
	    OFusion.log("dilandau: response: " + xmlString);
            xmlString.replace(/<a class="dilandau_download" rel="nofollow" href="([^"]*)"/g, function () {
                matches.push(Array.prototype.slice.call(arguments, 1, 2));
		OFusion.log("matches pushing: " + Array.prototype.slice.call(arguments,1,2));
            });

            var matchesTitle = [];
            //xmlString.replace(/title="">([^"]*)</a>/g, function () {
            xmlString.replace(/title="" >([^"]*)<\/a>/g, function () {
                matchesTitle.push(Array.prototype.slice.call(arguments, 1, 2));
		OFusion.log("title pushing: " + Array.prototype.slice.call(arguments,1,2));
            });

            //TODO duration are not yet accurate on dilandau
            //var matchesDuration = [];
            //xmlString.replace(/<meta itemprop="duration" content="([^"]*)"/g, function() {
            //  matchesDuration.push(Array.prototype.slice.call(arguments,1,2));
            //});
            var results = [];
            var limit = 5; // how many checks we should do
            var current = 0; // how many valid urls we have tried to check
            var count = 0; // how many checks we've received results for
            if (matches.length > 0 && matches.length == matchesTitle.length) {
                // walk through the results and store it in 'results'
                for (var i = 0; i < matches.length; i++) {
                    var link = matches[i];
                    var dTitle = matchesTitle[i];
                    var dTitleLower = dTitle.toString().toLowerCase();

                    var dDuration = 0;
                    //TODO Currently dilandau duration are not accurate.
                    //if(matchesDuration.length == matchesTitle.length) {
                    //OFusion.log(matchesDuration[i]);
                    //dDuration = this.parseISODuration(matchesDuration[i].toString());
                    //}
                    if (!strictMatch || (dTitleLower.indexOf(artist.toLowerCase()) !== -1 && dTitleLower.indexOf(title.toLowerCase()) !== -1)) {
                        current = current + 1;
                        if (current > limit) // this is it
                            break;

                        var result = {};
                        result.artist = artist;
                        result.album = album;
			if(strictMatch)
				result.track = title;
			else
				result.track = dTitle;
			var stropt = new com.lava.stringoptimize.StringOptimize();
			result.track = stropt.optimizeStringSimple(result.track) + ".mp3";
                        result.duration - dDuration;

                        result.source = that.settings.name;
                        result.url = decodeURI(link);

                        result.mimetype = "audio/mp3";
                        result.bitrate = 128;
                        if (strictMatch)
                            result.score = .9;
                        else
                            result.score = 0.5;

			if(!strictMatch)
			{
				results.push(result);
				count = count + 1;
				if(count == limit)
				{
					var return1 = {
						qid: qid,
						results: results
					};
					OFusion.addTrackResults(return1);
				}
			}
			else
			{
				(function(result) {
					var xhr = new XMLHttpRequest();
					xhr.open("HEAD", result.url, true);
					xhr.onreadystatechange = function() {
						if (xhr.readyState !== 4)
					return;
				if (xhr.status === 200 || xhr.status === 206) { // We accept 200 (OK) and 206 (Partial Content)
					OFusion.log("Found 200/206 mp3 url, pushing : " + result.url);
					results.push(result)
				} else {
					OFusion.log("Found 404'ed mp3 url, ignoring: " + result.url);
					//OFusion.log("GOT HEADER CHECK FOR: " + result.url);
					// OFusion.log("XHR STATE CHANGED: " + xhr.readyState);
					// OFusion.log("XHR STATUS: " + xhr.status);
                                	}
				count = count + 1;
				
                                if (count == limit) {
					OFusion.log("Found all playable urls, sending results to OFusion!");
					var return1 = {
						qid: qid,
						results: results
					};
					OFusion.addTrackResults(return1);
				}
					};
				//OFusion.log("Sending check for: " + result.url);
				xhr.send(null);
				})(result);
			}
		    } else {
			OFusion.log("dilandau: ignoring result");
                        count = count + 1;
                    }
                }
            }
        }
    },

    resolve: function (qid, artist, album, title) {
	    var return1 = {
		    qid: qid,
		    results: new Array()
	    };
	    return return1;
    },

    //saurabh: original dilandau resolver didnt have any search functionality
    search: function (qid, searchString) {
	OFusion.log("dilandau:search ");
        var url = "http://www.dilandau.eu/download_music/";
        var request = "";
        request += searchString.replace(/ /g, '-');
        url += encodeURIComponent(request)

        url += "-1.html";
        // send request and parse it into javascript
        OFusion.asyncRequest(url, this.handleResponse(qid, "", "", searchString,false));
    }
});

OFusion.resolver.instance = DilandauResolver;
